#include<stdio.h>
#define MAXPOINTS	500010
long px[MAXPOINTS],py[MAXPOINTS],h[MAXPOINTS],numpoints,hullnum;

long findhull() {
	long i,j,k,l,z,zz,x1,x2,y1,y2,cx,cy,ohullnum,gap;
	x1=0; y1=0; x2=0; y2=0;
	for(z=numpoints-1;z>0;z--)
	{
		if((px[z]<px[x1]) || ((px[z]==px[x1]) && (py[z]<py[x1]))) x1=z;
		if(py[z]<py[y1]) y1=z;
		if(px[z]>px[x2]) x2=z;
		if(py[z]>py[y2]) y2=z;
	};
	cx=px[x1]; cy=py[x1];
	hullnum=0;
	for(z=0;z<numpoints;z++)
	{
		if(z==x1) continue;
		if((px[z]-px[x1])*(py[y1]-py[x1]) >= (py[z]-py[x1])*(px[y1]-px[x1]))
			h[hullnum++]=z;
		else if((px[z]-px[y1])*(py[x2]-py[y1]) >= (py[z]-py[y1])*(px[x1]-px[y1]))
			h[hullnum++]=z;
		else if((px[z]-px[x2])*(py[y2]-py[x2]) >= (py[z]-py[x2])*(px[y2]-px[x2]))
			h[hullnum++]=z;
		else if((px[z]-px[y2])*(py[x1]-py[y2]) >= (py[z]-py[y2])*(px[x1]-px[y2]))
			h[hullnum++]=z;
	};
	gap=1;
	while(gap<hullnum) gap=(gap<<1)+1;
	for(gap>>=1; gap>0;gap>>=1)
		for(i=0,k=hullnum-gap;i<k;i++)
		{
			l=i; j=h[l+gap];
			if((py[h[l]]-cy)*(px[j]-cx) > (py[j]-cy)*(px[h[l]]-cx))
			{
				do
				{
					h[l+gap]=h[l]; l-=gap;
					if(l<0) break;
				} while((py[h[l]]-cy)*(px[j]-cx) > (py[j]-cy)*(py[h[l]]-cx ));
				h[l+gap]=j;
			};
		};

	z=1; ohullnum=hullnum-1;
	for(zz=2; zz<=ohullnum;zz++)
	{
		while((px[h[z]]-px[h[z-1]])*(py[h[zz]]-py[h[z]]) <=
				(py[h[z]]-py[h[z-1]])*(px[h[zz]]-px[h[z]]))
		{
			hullnum--;
			z--; if(!z) break;
		};
	z++; h[z]=h[zz];
	};
h[hullnum++]=x1;
return hullnum;
};

#define KW(a)  ((long long)(a)*(a))
#define dist(a,b) ( KW(px[h[b]]-px[h[a]])+KW(py[h[b]]-py[h[a]]) )


int main() {
	int nt;
	int n,i,x,y;
	int nv;
	long long maxd;
	int a,step,b;
	scanf("%d",&nt);
	while(nt--) {
		maxd=0;
		scanf("%d",&n);
		for(i=0;i<n;i++) {
			scanf("%d%d",&x,&y);
			px[i]=x;
			py[i]=y;
			};
		numpoints=n;
		findhull();
		for(i=0;i<hullnum;i++) {
			a=0;
			b=n-1;
			step=1;
			while(step<hullnum) {
				if(dist(i,a)>dist(i,a+step)) break;
				a+=step;
				step<<=1;
				};
			step/=2;
			while(step>1) {
				if(dist(i,a)>dist(i,a-step)) break;
				a-=step;
				step>>=1;
				};
			if(maxd<dist(i,a)) maxd=dist(i,a);
			};
		printf("%lld\n",maxd);
		};
	return 0;
	}
